using System;
using System.Xml;
using System.Xml.XPath;
using System.Collections;

namespace com.lblabs.xmltool.csharp
{
	/// <summary>
	/// Summary description for CSharpXMLSearcher.
	/// </summary>
	public class CSharpXMLSearcher
	{
		public CSharpXMLSearcher()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public string selectByKeyTag(string xmlFile, string rootTag, string keyTag)
		{
			string resultStr = null;
			XPathDocument xpDoc = new XPathDocument(xmlFile);
			XPathNavigator xpNav = xpDoc.CreateNavigator();
					
			XPathNodeIterator xpIter = xpNav.SelectDescendants(rootTag, "http://www.lblabs.com/Contact",true);

			//Get to the ContactDetails node itself
			xpIter.MoveNext();
			
			//Get all the last name nodes
			XPathNodeIterator xpIterNoFirst = xpNav.SelectDescendants(keyTag, String.Empty,false);
			
			while (xpIterNoFirst.MoveNext())
			{
				resultStr = xpIterNoFirst.Current.Value;
				XPathNodeIterator xpIterCont = xpIterNoFirst.Current.SelectAncestors("Response", String.Empty,false);
			}
			return resultStr;
		}

		public Hashtable selectByKeyTagForHash(string xmlFile, string rootTag, string keyTag)
		{
			Hashtable resultHash = new Hashtable();
			XPathDocument xpDoc = new XPathDocument(xmlFile);
			XPathNavigator xpNav = xpDoc.CreateNavigator();
					
			XPathNodeIterator xpIter = xpNav.SelectDescendants(rootTag, "http://www.lblabs.com/Contact",true);

			//Get to the ContactDetails node itself
			xpIter.MoveNext();
			
			//Get all the last name nodes
			XPathNodeIterator xpIterNoFirst = xpNav.SelectDescendants(keyTag, String.Empty,false);

			int index = 0;

			while (xpIterNoFirst.MoveNext())
			{
				resultHash.Add(index ++, xpIterNoFirst.Current.Value);
				XPathNodeIterator xpIterCont = xpIterNoFirst.Current.SelectAncestors("Response", String.Empty,false);
			}
			return resultHash;
		}
	}
}
