using System;
using System.IO;

namespace com.lblabs.backend.csharp
{
	/// <summary>
	/// Summary description for FileProcessor.
	/// </summary>
	public class CSharpFileProcessor
	{
		public CSharpFileProcessor()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public bool cp(string sourceFile, string targetFile)
		{
			bool isCopySuccessful = false;
			try
			{
				File.Copy(sourceFile, targetFile, true);
				isCopySuccessful = true;
			}
			catch (Exception e)
			{
				Console.WriteLine("Double copying is not allowed, as expected.");
				Console.WriteLine(e.ToString());
				isCopySuccessful = false;
			}
			return isCopySuccessful;
		}

		public string getFilePath(string fullFileName)
		{
			int slashSymbolIndex = fullFileName.LastIndexOf("\\");
			string fullPath = fullFileName.Substring(0, slashSymbolIndex);
			return fullPath;
		}

		public string getFileName(string fullFileName)
		{
			int slashSymbolIndex = fullFileName.LastIndexOf("\\");
			string fileName = fullFileName.Substring(slashSymbolIndex + 1);
			return fileName;
		}
	}
}
